#pragma once

//#define TESTING //comment this out to use test harness

/**************************************************************
 * Filename:
 * Contents:
 *
 * Notes:    Target: Arduino UNO R1 & R2
 * Arduino IDE version: 0022
 *
 * History:
 * when      who  what/why
 *
 **************************************************************/

/*---------------- Includes ---------------------------------*/
#include "stateMachine.h"
#include "definitions.h"
#include <Timers.h>
#include "drive.h"
#include "beaconSense.h"
#include "tapeSense.h"

#define NUM_READS 2


/*---------------- Main Code ---------------------------------*/



void setup() {
    Serial.begin(9600);
    TMRArd_InitTimer(MOVE_TIMER, 0);
    TMRArd_InitTimer(TURN_TIMER, 0);

    Drive_InitMotors();

    BeaconSense_Initialize();

    Drive_Stop();
    
    //Drive_Turn(LEFT, 255);

    //Drive_Move(BACK, 255);
    
}

void loop() {

    //to keep track of the last direction the enemy was in for the case we don't see the enemy on any sensors.
    static Direction turnDir = LEFT;

    int rightSum = 0;
    int leftSum = 0;
    int frontSum = 0;

    for ( int i = 0 ; i < NUM_READS ; i++){ //25
	//delay(20);
	//sumReadings+= isEnemyInFrontBeacon();
	rightSum += check_RightSensor();
	leftSum += check_LeftSensor();
	frontSum += check_FrontSensor();


    }

    //charge if all active, R and L active, or F active
    if ( (frontSum == NUM_READS && rightSum == NUM_READS && leftSum == NUM_READS) ||
	 (rightSum == NUM_READS && leftSum == NUM_READS) ||
	 (frontSum == NUM_READS) ) {
//     if ( frontSum == NUM_READS ) {
	Serial.println("CHARGE!!!");
	Drive_Move(FORWARD, 255);
	delay(300);

    }

    else if ( leftSum == NUM_READS && !(frontSum == NUM_READS) ) {
	Serial.println("Turning Left!");
	Drive_Turn(LEFT, 200);
	turnDir = LEFT;
    }

    else if ( rightSum == NUM_READS && !(frontSum == NUM_READS) ) {
	Serial.println("Turning Right!");
	Drive_Turn(RIGHT, 200);
	turnDir = RIGHT;
    }

    else {
	Drive_Turn(turnDir, 230);
    }

    
    
}
